//
// control.h
//
// Game loop, drawing, event handling.
//
// Todo: Improve handling
//

void GameLoop ()
{
  static S4 i = 0;
  S2 Ende = 0,
    j = 0,
    mx_old,
    my_old;

  gii_event_mask mask;
  gii_event event;

  while (!Ende)
  //Loop while the program is running.
  {
    struct timeval tval;
    tval.tv_sec = 0;
    tval.tv_usec = 0;
    //We won't wait for events, only handle the ones just occuring /now/.
    while ((mask = ggiEventPoll (vis, emAll, &tval)) != 0)
    //Loop while there's an event to handle.
    {
      mx_old = mx;
      my_old = my;
      //Save the old mouse coordinates.
      ggiEventRead (vis, &event, emAll);
      //Break here and let's handle the event.
      switch (event.any.type)
      //Depending on the event, we call different routines.
      {
      case evPtrAbsolute: //We're moving the pointer absolute
        mx1=mx;my1=my;
        mx = event.pmove.x;
        my = event.pmove.y; //Check the new mouse coordinates.
        break;
      case evPtrRelative: //We're moving relative.
        mx1=mx;my1=my;
        mx += event.pmove.x;
        my += event.pmove.y; //Again, new mouse coordinates into my and mx.
        break;

      case evPtrButtonPress: //Button pressed.
        switch (event.pbutton.button)
        {
        case GII_PBUTTON_PRIMARY: //Primary button pressed. we drag a frame
          if (edit)
          {
            if(maus_innen(36,10,49,20)) PartSelect-=5;
            else if(maus_innen(36,22,49,34)) PartSelect+=5;
            else if(maus_innen(8,10,32,222)) EditSelect=((my-10)/(TS+1))+PartSelect;
            else
            {
              Karte[(my+ScrollY)/TS][(mx+ScrollX)/TS] = EditSelect;
              UpdateKarte((my+ScrollY)/TS,(mx+ScrollX)/TS);
            }
            if (PartSelect<0) PartSelect+=nTiles;
            PartSelect%=nTiles;
          }
          else
          if (!Rahmen) //If we didn't start dragging a frame yet, we do it now.
          {
            Rahmen = 1;
            RahmenX = mx;
            RahmenY = my; //Set the beginning of the frame.
          }
          break;
        case GII_PBUTTON_SECONDARY: //Right button pressed.
          if (!RightScroll) //Are we right-scrolling yet?
          {
            RightScroll = 1;
            RightScrollX = mx;
            RightScrollY = my; // If not, set the x and y coords for the start
                               // of scrolling
          }
          break;
        };
        break;
      case evPtrButtonRelease: //We release a button.
        switch (event.pbutton.button)
        {
        case GII_PBUTTON_PRIMARY: //We're releasing the left button.
          if (!edit)
          if (Rahmen == 2) // If we did indeed drag a frame...
          {
            for (i = 0; i < LMAX; i++) // Count through the units
            {
              Leute[i].aktive = 0; //Deactivate the current unit.
              if ((!Leute[i].feind) &&
                  (Leute[i].x >= min (mx, RahmenX)) &&
                  (Leute[i].x <= max (mx, RahmenX)) &&
                  (Leute[i].y >= min (my, RahmenY)) &&
                  (Leute[i].y <= max (my, RahmenY)))
              {
                // If it's not an enemy and within the frame, activate it.
                Leute[i].aktive = 1;
                MouseSet (2);
              }
            }
          }
          else //We didn't drag a frame, were just clicking on something.
          {
            int found = 0;
            for (i = 0; i<LMAX && !found ;) // Count through units 'til we 
                                            // 'found' the one we're clicking.
            {
              if (maus_innen (Leute[i].x, Leute[i].y, Leute[i].x + Leute[i].shapeX, Leute[i].y + Leute[i].shapeY) && (Leute[i].free))
                found = 1; //If there's a unit where we clicked, we 'found' it.
              else
                i++;
            }
            if (found) // If the 'found' flag is set...
            {
              if (Leute[i].feind)
              //...and the unit clicked is an enemy...
              {
                for (j = 0; j < LMAX; j++)
                //...count through the people...
                {
                  if (Leute[j].free && Leute[j].aktive && !Leute[j].feind)
                  {
                    // ...and make all activated friendly units attack.
                    Leute[j].attack = 1;
                    Leute[j].who = i;
                  }
                }
              }
              else
              //If we clicked on a friendly unit...
              {
                for (j = 0; j < LMAX; j++)
                  Leute[j].aktive = 0;
                  //Count through the units and deactivate them all...
                Leute[i].aktive = 1;
                //Activate the unit we clicked on.
              }
            }
            else
            { // We did not click on a unit (somewhere on the map)
              if (Karte[(my+ScrollY) / TS][(mx+ScrollX) / TS] <= Hindernis)
              // Check whether we can go there.
              {
                for (j = 0; j < LMAX; j++)
                //Count through the units.
                {
                  if (Leute[j].free && Leute[j].aktive && !Leute[j].feind)
                  // If the current unit is friendly and active...
                  {
                    // ...let it go to where we clicked.
                    Leute[j].attack = 0;
                    Leute[j].dx = mx + ScrollX;
                    Leute[j].dy = my + ScrollY;
                    Leute[j].dcount = Leute[j].d1count = 0;
                    WegSuchen (j);
                  }
                }
              }
            }
          }
          Rahmen = 0; //Reset the frame-flag.

          break;
        case GII_PBUTTON_SECONDARY: //Right button was pressed.
          if (RightScrolled != 2) 
          // If we were not scrolling with the rbutton, deactivate all people.
          {
            for (i = 0; i < LMAX; i++)
              if (Leute[i].aktive)
                Leute[i].aktive = 0;
          }
          RightScroll = RightScrolled = 0; //Reset the scroll-flag.
          break;
        };
        break;
      case evKeyPress: //We pressed a key.
        i = event.key.sym;
        if (i == 27) Ende = 1; // On ESC we want to quit.
        if (i == 'h')
          HauptMenu(); //'h' displays the main menu.

        if (i == '^')
          edit = !edit; //'^' gets us into EDIT mode.
        if (i == 9) // '9' to select units.
          for (j = 0; j < LMAX; j++)
            if ((Leute[j].free) && (Leute[j].x > Mlinks) && (Leute[j].x < Mrechts) && (Leute[j].y > Moben) && (Leute[j].y < Munten) && (!Leute[j].feind))
            {
              Leute[j].aktive = 1;
              MouseSet (2);
            }
        if (i == 'x') //'x' to spread them out.
          for (j = 0; j < LMAX; j++)
            if (Leute[j].aktive)
            {
              Leute[j].dx += rand () % 20;
              Leute[j].dy -= rand () % 20;
            }
        // no break because of Key repeats
      case evKeyRepeat:
        i = event.key.sym;
        if (edit)
        {
          if ('1'<=i && i<='9')
          {
            sprintf(MapFile,"mission/map0%c.mis",i);
            LoadMap();
          }
          if (i == 's') SaveMap();

        }
        else
        {
          if ('1'<=i && i<='4')
            MInsert (ScrollX + mx, ScrollY + my, ScrollX + mx, ScrollY + my, i - '1');
          if ('a'<=i && i<='d')
            FInsert (ScrollX + mx, ScrollY + my, ScrollX + mx, ScrollY + my, i - 'a'+4);
          if (i == '5')
            MInsert (ScrollX + mx, ScrollY + my, ScrollX + mx, ScrollY + my, 8);
          if (i == '6')
            MInsert (ScrollX + mx, ScrollY + my, ScrollX + mx, ScrollY + my, 9);
        }
        if (i == GIIK_Up) PartSelect-=5;
        if (i == GIIK_Down) PartSelect+=5;
        if (PartSelect<0) PartSelect+=nTiles;
        PartSelect%=nTiles;

        if (i == '+')
          GameSpeed >>= 1;
        if (i == '-')
          GameSpeed <<= 1;
        GameSpeed=minmax(1,GameSpeed,10);
      break;
      case evKeyRelease:
      break;
      case evExpose:
        //redraw_screen(event.expose.x, event.expose.y,event.expose.w, event.expose.h); // redraw part of screen...
        break;
      case 1:
      break;
      default:
        printf ("Ein unerwartetes Ereignis ist aufgetreten: event.any.type=%d\n",event.any.type);
      }
      mx = minmax (0, mx, WIDTH - 1); //If the mouse hits the limits of the map, put it 
      my = minmax (0, my, HEIGHT - 1); //Within the boundries.
      if (mx_old != mx || my_old != my)	//Mouse moved

      {
        if (Rahmen == 1)
          Rahmen = 2; //We started dragging a frame, let's finish it.

        if (RightScroll) //IF we started scrolling with the right button...
        {
          if ((mx < RightScrollX) && (ScrollX > 0))
          // We moved the mouse to the left, so scroll to the left.
          {
            ScrollLeft ();
            NachScroll = RightScrollX - mx;
            ScrollDir = 1;
          }
          if ((mx > RightScrollX) && (ScrollX < (FeldX*TS) - WIDTH))
          {
            //Same as above, but to the right.
            ScrollRight ();
            NachScroll = mx - RightScrollX;
            ScrollDir = 2;
          }
          if ((my < RightScrollY) && (ScrollY > 0))
          {
            //...and to the top...
            ScrollUp ();
            NachScroll = RightScrollY - my;
            ScrollDir = 3;
          }
          if ((my > RightScrollY) && (ScrollY < (FeldY*TS) - HEIGHT - TS))
          {
            //...and to the bottom.
            ScrollDown ();
            NachScroll = my - RightScrollY;
            ScrollDir = 4;
          }
          RightScrollX = mx;
          RightScrollY = my;
          // Finally, set the scrolling coordinates to the current mouse corrdinates,
          // In case we want to scroll on.
        }

      }
    };
    //End of event handling.


    NachScrollen ();            // Scroll out softly.

    DoScroll ();                // Scrolls, if the mouse hits the borders of the screen.

    // Now we set the form of the mousecursor.
    if (MouseImage != 2)
      MouseSet (0);

    if (Karte[(my+ScrollY) / TS][(mx+ScrollX) / TS] > Hindernis)
      MouseSet (1);
      // If we're pointing at a 'suitable' area, set mouse to pointertype 1.

    for (i = 0; i < LMAX; i++)
    {
      if (maus_innen (Leute[i].x, Leute[i].y, Leute[i].x + Leute[i].shapeX, Leute[i].y + Leute[i].shapeY) && Leute[i].free)
        MouseSet (Leute[i].feind ? 4 : 3);
        // If the mouse points at a unit, set it to form 3 if it's friendly, 4 if it's enemy.
    }

    Landschaft ();              // Draw a new frame

    if (edit)
      PutSprite (((ScrollX+mx)/TS)*TS-ScrollX,((my+ScrollY)/TS)*TS-ScrollY, EditSelect);

    if (!edit) for (i = 0; i < LMAX; i++)
      if (Leute[i].free)
      {
        Leute[i].warten++;
        if (Leute[i].warten >= (Data[Leute[i].type].speed + GameSpeed))
        {
          MVerhalten (i);
          Leute[i].warten = 0;
        }
        if (Leute[i].aktive)
          MouseImage = 2;
          // If we have active people, set the mouseimage to image 2.
        Leute[i].x = Leute[i].ax - ScrollX;
        Leute[i].y = Leute[i].ay - ScrollY;
        if ((Leute[i].x < Mrechts) && (Leute[i].x + 20 > Mlinks) && (Leute[i].y < Munten) && (Leute[i].y + 20 > Moben))
        {
          if ((Leute[i].aktive) && (!Leute[i].feind))
            MSetAkt (i);
          else
            MSet (i);
        }
      }

    if (!edit) for (i = 0; i <= EMAX; i++)
    {
      if (Explose[i].free == 1)
        ExploseCompute (i);
      if (Laser[i].free == 1)
        LaserCompute (i);
      if (Rauch[i].free == 1)
        RauchCompute (i);
      if (Rocket[i].free == 1)
        RocketCompute (i);
    }

    // Zeichnet den Rahmen falls ntig
    if (Rahmen == 2)
      draw_box (min (mx, RahmenX), min (my, RahmenY), max (mx, RahmenX), max (my, RahmenY), GELB_HELL);

    InterFace ();               // Zeichnet das BenutzerInterface

    if (edit)
    {
      ShowSpriteSelect ();
      ShowEditInterface ();
    }
    MouseBackSave();
    MousePlace();

#if 0
    for (m_show_image = 0; m_show_image < 15; m_show_image++)
    {
      mx = m_show_image * 30 + 10;
      my = 20;
      MousePlace ();
    }
#endif

    GameDel++;
    if (GameDel >= GameSpeed)
    {
      GameDel = 0;

      m_show_image++;
      if (m_show_image >= m_image_end)
        m_show_image = m_image_start;

      AniKarte ();
    }
    Iwrite(50,50, mx, 254);
    Iwrite(70,50, my, 254);
    Iwrite(100,50, FeldX, 254);
    Iwrite(120,50, FeldY, 254);
    Iwrite (1, 1, LaserAnz, 254);
    Cpy2Screen ();
    if(!FAnz || !MAnz) Ende=1;
  }
}
