//
// maps.h
//
// Redesign Memory Management

void MInsert ( short ax, short ay, short dx, short dy, U1 type );


void DecodeKarte(void)
{
  int i,j,k,l;
  U2 puffer,farbe,farbe2;
  U1 Data;

  for (i = 0; i < (FeldY * TS) - TS; i += TS)	// Schleife fr Y-Richtung ( in Byte )
  {
    for (j = 0; j < FeldX; j++) // Schleife fr X-Richtung ( in 20er Blcken )
    {
      for (k = 0; k < TS; k++)
      {
        for (l = 0; l < TS; l++)
        {
          puffer = Karte[i / TS][j];
          farbe = (rand () % 5) + 1;
          farbe2 = (rand () % 16) + 72;
          Data=TerrainData[(puffer * TS*TS) + (k * TS) + l];
          Terrain[(i*2000) + (j*TS) + (k*2000) + l] = (Data<6 && Data!=0) ? farbe : Data;
        }
      }
    }
  }
}

void UpdateKarte(int i,int j)
{
  int k, l;
  U2 puffer, farbe, farbe2;
  U1 Data;

  i*=TS;
  for (k = 0; k < TS; k++)
  {
    for (l = 0; l < TS; l++)
    {
      puffer = Karte[i / TS][j];
      farbe = (rand () % 5) + 1;
      farbe2 = (rand () % 16) + 72;
      Data=TerrainData[(puffer * TS*TS) + (k * TS) + l];
      Terrain[(i*2000) + (j*TS) + (k*2000) + l] = (Data<6 && Data!=0) ? farbe : Data;
    }
  }
}

void InitKarte (void)
{
  short i,
    j;

  for (i = 0; i < FeldY; i++)
  {
    for (j = 0; j < FeldX; j++)
    {
      //printf("%d ",Karte[i][j]);  
      switch (Karte[i][j])
      {
      case 662:
        Animated[AniAnz].x = j * 20;
        Animated[AniAnz].y = i * 20;
        Animated[AniAnz].start = 662;
        Animated[AniAnz].ende = 675;
        Animated[AniAnz++].index = 662 + (rand () % (675 - 662));
        break;
      case 676:
        Animated[AniAnz].x = j * 20;
        Animated[AniAnz].y = i * 20;
        Animated[AniAnz].start = 676;
        Animated[AniAnz].ende = 687;
        Animated[AniAnz++].index = 676 + (rand () % (687 - 676));
        break;

      case 700:
        Animated[AniAnz].x = j * 20;
        Animated[AniAnz].y = i * 20;
        Animated[AniAnz].start = 700;
        Animated[AniAnz].ende = 706;
        Animated[AniAnz++].index = 700 + (rand () % 6);
        break;
      case 101:
        //MInsert (j*20, i*20, j*20, i*20, 0);
      break;
      }
    }
    //printf("\n");
  }
}


void InitXYKarte (void)
{
  short x,
    y,
    i,
    j;
  printf("InitXKarte ...\n");
  for (y = 0; y <= FeldY; y++)
  {
    for (x = 0; x <= FeldX; x++)
    {
      if (Karte[y][x] >= Hindernis)
      {
        for (i = x; i <= FeldX; i++)
        {
          if (Karte[y][i] >= Hindernis)
            XKarte[y][i].anfang = x;
          else
            goto weiter;
        }
      weiter:
        for (j = x; j <= i; j++)
          XKarte[y][j].ende = i;
        x = i;
      }
      else
        XKarte[y][x].anfang = XKarte[y][x].ende = 0;

    }
  }
  printf("InitYKarte ...\n");
  for (x = 0; x <= FeldX; x++)
  {
    for (y = 0; y <= FeldY; y++)
    {
      if (Karte[y][x] >= Hindernis)
      {
        for (i = y; i <= FeldY; i++)
        {
          if (Karte[i][x] >= Hindernis)
            YKarte[i][x].anfang = y;
          else
            goto weiter1;
        }
      weiter1:
        for (j = y; j <= i; j++)
          YKarte[j][x].ende = i;
        y = i;
      }
      else
        XKarte[y][x].anfang = XKarte[y][x].ende = 0;
    }
  }
  printf("XYKarten initialisiert.\n");
}


void AniKarte (void)
{
  short i,
    j;

  for (i = 0; i < AniAnz; i++)
  {
    if (Animated[i].index >= Animated[i].ende)
      Animated[i].index = Animated[i].start;
    for (j = 0; j < TS; j++)
      memcpy (&Terrain[(Animated[i].y + j) * (MAP_X * TS) + Animated[i].x], &TerrainData[(Animated[i].index * TS*TS) + (j * TS)], TS);
    Animated[i].index++;
  }
}

void Landschaft (void)
{
  short i;
  ScrollX = minmax(0,ScrollX,FeldX*TS - WIDTH);
  ScrollY = minmax(0,ScrollY,FeldY*TS - HEIGHT - 20);

  for (i = 0; i < Munten; i++)
    memcpy (&VScreen[i * WIDTH], &Terrain[((ScrollY + i) * TS * MAP_X) + ScrollX], Mrechts);
}
void LoadMap ()
{
  FILE *D;
  char sign[2];

  if ((D = fopen (MapFile, "rb")) == NULL)
  {
    printf ("Kann Datei '%s' nicht laden!\n", MapFile);
  }

  // Header
  fread (sign, sizeof (sign), 1, D);
  FeldX = fgetc (D);
  FeldY = fgetc (D);

  // Karte speichern
  fread (*Karte, sizeof (Karte), 1, D);

  fclose (D);

  DecodeKarte();
  InitXYKarte();
  InitKarte();

}

void SaveMap ()
{
  FILE *D;
  char sign[2];

  if ((D = fopen (MapFile, "wb")) == NULL)
  {
    printf ("Kann Datei '%s' nicht sichern!\n", MapFile);
  }

  // Header
  fwrite (sign, sizeof (sign), 1, D);
  fputc(FeldX,D);
  fputc(FeldY,D);

  // Karte speichern
  fwrite (*Karte, sizeof (Karte), 1, D);

  fclose (D);
}
